// Egoboo - Font.h
// True-type text drawing interface.

#ifndef egoboo_Font_h
#define egoboo_Font_h

#define FNT_NUM_FONT_CHARACTERS 94
#define FNT_SMALL_FONT_SIZE 12
#define FNT_NORMAL_FONT_SIZE 16
#define FNT_LARGE_FONT_SIZE 20
#define FNT_MAX_FONTS 8

typedef struct Font Font;

extern Font		*fnt_loadFont(const char *fileName, int pointSize);
extern void		fnt_freeFont(Font *font);

extern void		fnt_drawText(Font *font, int x, int y, const char *text);
extern void		fnt_drawTextBox(Font *font, const char *text, int x, int y, int width, int height, int spacing);

// Only works properly on a single line of text
extern void		fnt_getTextSize(Font *font, const char *text, int *width, int *height);
// Works for multiple-line strings, using the user-supplied spacing
extern void		fnt_getTextBoxSize(Font *font, const char *text, int spacing, int *width, int *height);
#endif // include guard
