// Egoboo - Ticker.h
// Time-keeping objects that track how many updates should occur within
// a given timespan

#ifndef egoboo_Ticker_h
#define egoboo_Ticker_h

typedef struct Ticker
{
	double lastTime;
	double tickInterval;
	int numTicks;
}Ticker;

extern void ticker_initWithInterval(Ticker *ticker, double interval);
extern void ticker_initWithFrequency(Ticker *ticker, int freq);

extern void ticker_update(Ticker *ticker);
extern int  ticker_tick(Ticker *ticker);

#endif // include guard
